import 'dart:html';

var variable_map = [];
var accept_row = [];
var accept_row_map = new Map();

void main() {
  // Load Data
  var tbody = query("#f tbody"); 
  tbody.children.forEach(fillVariableMap);
  
  // Add filter fields to table
  var filterRow = new TableRowElement();
  if (variable_map.length > 0) {
    for (int i = 0; i< variable_map[0].length; i++) {
      // Create input element
      var input = new InputElement();
      input.on.keyUp.add(applyFilter);
      input.attributes['position'] = i.toString();

      // Create cell for table with Input Element
      var cell = new TableCellElement();      
      cell.append(input);
      
      filterRow.append(cell);
    }
  }
  
  // Append handle to fields
  query("#f thead").append(filterRow);
}

void applyFilter(e) {
  // Aplly filtration to table
  
  // Read filters data
  var rows = query("#f tbody").children;
  var filter_inputs = queryAll("#f thead input");
  var filter_column = 0;
  var etalon = [];
  
  for (var input in filter_inputs) {
    // Read filter values
    var filter_value = new StringBuffer();
    filter_value.add(input.value.toLowerCase());
    
    // Create empty map for column
    accept_row_map[filter_column] = [];
    if (filter_value.toString().length <= 0) {
      // If filter is empty accept all rows
      
      for (int i = 0; i < variable_map.length; i++) {
        accept_row_map[filter_column].add(i);
        
        // add clear massive
        if (filter_column == 0) {
          etalon.add(i);
        }
      }
      
    } else {
      // If filter have value
      
      for (int i = 0; i< variable_map.length; i++) {
        if (variable_map[i][filter_column].contains(filter_value.toString())) {
          // we found our row
          
          if (accept_row_map[filter_column].indexOf(i) < 0) {
            accept_row_map[filter_column].add(i);        
          }
        }

        // add clear massive
        if (filter_column == 0) {
          etalon.add(i);
        }
      }
    }
    
    filter_column++;
  }
  
  // compare columns filter
  accept_row = [];
  var map_keys_len = accept_row_map.keys.length;
  
  for (var e_val in etalon) {
    var score = 0;
    for (int i = 0; i < map_keys_len; i++) {
      // we found compare of rows - add score
      if (accept_row_map[i].indexOf(e_val) >= 0) {
        score++;
      }
    }
    
    if (score == map_keys_len && accept_row.indexOf(e_val) < 0) {
      accept_row.add(e_val);
    }
  }
  
  // Hide inactive rows
  var pos = 0;
  for (var row in rows) {
    if (accept_row.indexOf(pos) < 0) {
      row.style.display = "none";
    } else {
      row.style.display = "table-row";
    }
    pos++;
  }
}

void fillVariableMap(Element Row) {
  // fill Variable map
  
  var cellsData = new List<String>();
  Row.children.forEach((f) => cellsData.add(f.text.toLowerCase()));
  
  variable_map.add(cellsData);
}
